Name:        pcre2
Version:     10.33
Release:     4
Summary:     Perl Compatible Regular Expressions
License:     BSD
URL:         http://www.pcre.org/
Source0:     https://ftp.pcre.org/pub/pcre/%{name}-%{version}.tar.bz2

Patch0:      Implement-a-check-on-the-number-of-capturing-parenth.patch
Patch1:      CVE-2019-20454.patch

BuildRequires:  autoconf libtool automake coreutils gcc make readline-devel
Obsoletes:      pcre2-utf16 pcre2-utf32 pcre2-tools
Provides:       pcre2-utf16 pcre2-utf32 pcre2-tools
Provides:       bundled(sljit)

%description
PCRE2 is a re-working of the original PCRE1 library to provide an entirely new
API. Since its initial release in 2015, there has been further development of
the code and it now differs from PCRE1 in more than just the API.
PCRE2 is written in C, and it has its own API. There are three sets of
functions, one for the 8-bit library, which processes strings of bytes, one for
the 16-bit library, which processes strings of 16-bit values, and one for the
32-bit library, which processes strings of 32-bit values. Unlike PCRE1, there
are no C++ wrappers.

The distribution does contain a set of C wrapper functions for the 8-bit
library that are based on the POSIX regular expression API (see the pcre2posix
man page). These are built into a library called libpcre2-posix. Note that this
just provides a POSIX calling interface to PCRE2; the regular expressions
themselves still follow Perl syntax and semantics. The POSIX API is restricted,
and does not give full access to all of PCRE2's facilities.

%package devel
Summary:     Development files for %{name}
Requires:    %{name} = %{version}-%{release}
Obsoletes:   pcre2-static
Provides:    pcre2-static

%description devel
%{summary}.

%package help
Summary:    Man pages for %{name}
BuildArch:  noarch

%description help
%{summary}.

%prep
%autosetup -n %{name}-%{version} -p1

autoreconf -vif

%build
%configure \
%ifarch riscv64
    --disable-jit \
%else
    --enable-jit \
%endif
    --enable-pcre2grep-jit \
    --disable-bsr-anycrlf \
    --disable-coverage \
    --disable-ebcdic \
    --disable-fuzz-support \
    --disable-jit-sealloc \
    --disable-never-backslash-C \
    --enable-newline-is-lf \
    --enable-pcre2-8 \
    --enable-pcre2-16 \
    --enable-pcre2-32 \
    --enable-pcre2grep-callout \
    --enable-pcre2grep-jit \
    --disable-pcre2grep-libbz2 \
    --disable-pcre2grep-libz \
    --disable-pcre2test-libedit \
    --enable-pcre2test-libreadline \
    --disable-rebuild-chartables \
    --enable-shared \
    --enable-static \
    --enable-unicode \
    --disable-valgrind \
    --disable-silent-rules

%make_build

%install
%make_install

#Unpacked files
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la

%check
make check

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%license %{_pkgdocdir}/{COPYING,LICENCE}
%doc AUTHORS ChangeLog NEWS HACKING README
%{_libdir}/libpcre2-8.so.*
%{_libdir}/libpcre2-posix.so.*
%{_libdir}/libpcre2-16.so.*
%{_libdir}/libpcre2-32.so.*
%{_bindir}/pcre2grep
%{_bindir}/pcre2test

%files devel
%{_includedir}/*.h
%{_libdir}/*.so
%{_libdir}/*.a
%{_libdir}/pkgconfig/*
%{_bindir}/pcre2-config
%doc ./src/pcre2demo.c

%files help
%{_mandir}/man1/*
%{_mandir}/man3/*
%{_pkgdocdir}/*.txt
%{_pkgdocdir}/html/

%changelog
* Tue Jun 2 2020 whoisxxx <zhangxuzhou4@huawei.com> - 10.33-4
- DESC: Disable jit for RISC-V

* Tue Apr 7 2020 openEuler Buildteam <buildteam@openeuler.org> - 10.33-3
- Type:cves
- ID:CVE-2019-20454
- SUG:NA
- DESC:fix CVE-2019-20454

* Mon Feb 3 2020 openEuler Buildteam <buildteam@openeuler.org> - 10.33-2
- Fix stack buffer overflow

* Sat Sep 14 2019 openEuler Buildteam <buildteam@openeuler.org> - 10.33-1
- Package init
